--Created by Joshua Garrett
--Description
    --Toast as many BOBs as possible. 

    Triggers = {}
    CollectionsUsed = { 1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,31 }
    
    timer = -1 
    PlayerSetupRun = 0 --used to check if player setup has been run since it cannot be run in Triggers.init and Triggers.idle runs every tick
    MonsterCount = 0
    MonsterLimit = 36
    StatCount = 0
    Combatants = {
        "green bob", 
        "security bob", 
        "blue bob", 
        "explodabob", 
        "tiny bob" 
    }
    
    function Triggers.init() 
        poly_init()
        monster_setup()
        table_length()
    end

    
    function Triggers.idle()
        timer = timer + 1
        if PlayerSetupRun == 0 then
        player_setup()
        PlayerSetupRun = 1
        end
        monster_spawning()       
        replenish_ammo()
        suppress_items()
    end

    function table_length() --used to see how many monsters/powerup are being used
        for k,v in ipairs(Combatants) do
            StatCount = StatCount + 1
        end
    end
    
    function poly_init()
        for poly in Polygons() do 
            poly._blacklisted = 0
            if poly.area <= 2 then
                poly._blacklisted = 1
            end
            if poly.type == "platform" then
                poly._blacklisted = 1
            end
            if poly.type  == "teleporter" then
                poly._blacklisted = 1
            end
                for plrstart in PlayerStarts() do 
                    if poly == plrstart.polygon then 
                        poly._blacklisted = 1
                    end
                end   
        end        
    end

    function player_setup()
        for plr in Players() do
            plr.items["pistol"] = 0
            plr.items["flamethrower"] = 1
            plr.items["flamethrower ammo"] = 7
            plr.weapons["flamethrower"]:select()
        end
    end

    function replenish_ammo()
        for plr in Players() do 
            if timer % 90 == 0 then 
                plr.items["flamethrower ammo"] = 7
            end
        end
    end

    function suppress_items()
        for i in Items() do 
            i:delete()
        end
    end

    function monster_spawning()
        spawn_chance = Game.random(24)
        for poly in Polygons() do
            if MonsterCount < MonsterLimit and spawn_chance == 0 then  
                monster_to_spawn = Game.random(StatCount) + 1 --pick a new monster to spawn
                    if poly._blacklisted == 0 then
                        Monsters.new(poly.x, poly.y, 0, poly, Combatants[monster_to_spawn]) --Create the new monster and spawn it on the polygon
                        MonsterCount = MonsterCount + 1
                    end
            end
		end
	end

    function monster_setup()
        for m in MonsterTypes() do
            for n in MonsterClasses() do
                m.enemies["player"]=true
                m.friends["player"]=false
                if n ~= "player" then
                    m.friends[n]=true
                    m.enemies[n]=false
                end
            end
        end
    end

    function Triggers.monster_killed(monster, aggressor_player, projectile)
        if not monster.player then
            MonsterCount = MonsterCount - 1
        end
        if not monster.player and aggressor_player then 
            aggressor_player.points = aggressor_player.points + 1
        end
    end 
    
    function Triggers.player_revived(player)
                player.items["pistol"] = 0
                player.items["flamethrower"] = 1
                player.items["flamethrower ammo"] = 7
                player.weapons["flamethrower"]:select()
    end


