--Created by Joshua Garrett
--Description
    --Kill as many BOBs as you can with a single life and only a pistol 

    Triggers = {}
    CollectionsUsed = { 1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,31 }
    
    timer = -1 
    PlayerSetupRun = 0 --used to check if player setup has been run since it cannot be run in Triggers.init and Triggers.idle runs every tick
    MonsterCount = 0
    MonsterLimit = 36
    LivingPlayers = 8
    StatCount = 0 
    Combatants = {
        "green bob", 
        "security bob", 
        "blue bob", 
        "explodabob", 
        "tiny bob" 
    }
    Spectateable = {}
    
    function Triggers.init()
        Game.nonlocal_overlays = true
        LivingPlayers = # Players
        poly_init()
        monster_setup()
        table_length()
        
    end

    function Triggers.idle()
        timer = timer + 1
        if PlayerSetupRun == 0 then
        player_setup()
        PlayerSetupRun = 1
        end
        suppress_items()      
        monster_spawning()
        player_update()
        replenish_ammo()
        disable_respawn()
        end_game()
    end

    function table_length() --used to see how many monsters/powerup are being used
        for k,v in ipairs(Combatants) do
            StatCount = StatCount + 1
        end
    end

    function poly_init()
        for poly in Polygons() do 
            poly._blacklisted = 0
            --PolyCount = PolyCount + 1
            if poly.area <= 2 then
                poly._blacklisted = 1
            end
            if poly.type == "platform" then
                poly._blacklisted = 1
            end
            if poly.type  == "teleporter" then
                poly._blacklisted = 1
            end
                for plrstart in PlayerStarts() do 
                    if poly == plrstart.polygon then 
                        poly._blacklisted = 1
                    end
                end   
        end        
    end

    function player_setup()
        for plr in Players() do
            plr._lives = 1
            plr._obituary = 0
            table.insert(Spectateable, plr.index)
            --plr.items["pistol"] = 1
            --plr.items["pistol ammo"] = 7
        end
    end

    function replenish_ammo()
        for plr in Players() do 
            if timer % 90 == 0 then 
                plr.items["pistol ammo"] = 7
            end
        end
    end

    function suppress_items()
        for i in Items() do 
            i:delete()
        end
    end

    function monster_spawning()
        spawn_chance = Game.random(24)
        for poly in Polygons() do
            if MonsterCount < MonsterLimit and spawn_chance == 0 then  
                monster_to_spawn = Game.random(StatCount) + 1 --pick a new monster to spawn
                    if poly._blacklisted == 0 then
                        Monsters.new(poly.x, poly.y, 0, poly, Combatants[monster_to_spawn]) --Create the new monster and spawn it on the polygon
                        MonsterCount = MonsterCount + 1
                    end
            end
		end
	end

    function monster_setup()
        for m in MonsterTypes() do
            for n in MonsterClasses() do
                m.enemies["player"]=true
                m.friends["player"]=false
                if n ~= "player" then
                    m.friends[n]=true
                    m.enemies[n]=false
                end
            end
        end
    end

    function Triggers.monster_killed(monster, aggressor_player, projectile)
        if not monster.player then
            MonsterCount = MonsterCount - 1
        end
        if not monster.player and aggressor_player then
            if monster.type == "tiny bob" then
                aggressor_player.points = aggressor_player.points + 1
            elseif monster.type == "green bob" then
                aggressor_player.points = aggressor_player.points + 2
            elseif monster.type == "blue bob" then
                aggressor_player.points = aggressor_player.points + 3
            elseif monster.type == "security" then
                aggressor_player.points = aggressor_player.points + 4
            elseif monster.type == "explodabob" then
                aggressor_player.points = aggressor_player.points + 5
            end
        end
    end 
    
    function Triggers.player_killed(player, aggressor_player, action, projectile)	 
        if player._lives > 0 then 
            player._lives = player._lives - 1
            if player.points >= 5 then 
            player.points = player.points - 5
            elseif player.points < 5 then
            player.points = 0
            end
        end
    end
    
    function player_update()
        for plr in Players() do
            if plr._lives == 0 and plr._obituary == 0 and LivingPlayers ~= 0 then
                Players.print(plr.name.." is no more")
                LivingPlayers = LivingPlayers - 1
                for k, v in ipairs(Spectateable) do
                    if plr.index == v then                       
                        table.remove(Spectateable, k)
                    end
                end
                plr._obituary = 1
                plr:view_player(Spectateable[1])
            end	
        end
    end

    function disable_respawn()
        for plr in Players() do
            if plr._lives == 0 then 
                plr.action_flags.action_trigger = false --sets the action_trigger to false effectively stopping respawn by blocking interact key interaction
            end
        end
    end

    function end_game()
        if LivingPlayers == 0 then
        Game.over = true
        end
    end

